#ifndef _PQUEUE_H
#define _PQUEUE_H 1

/*
ben definition af en prioritetesk instans. Denne kan
ndress efter behov, slnge det ikke ndrer p nedenstende
funktioners grnseflade.
*/

typedef struct pqueue_t {

  int pri;
  void *data;
  struct pqueue_t *prev;
  struct pqueue_t *next;

} pqueue_t;

pqueue_t *head;

/*
Indstter et elementet som 'elem' peger p, med prioriteten 'pri'.
Det er muligt at indstte flere elementer med samme prioritet.
'pq' peger p en instans af prioritetsken.

Lykkedes indsttelsen skal funktionen returnerer '0'. Ved fejl '-1'.
*/
int pqueue_insert(pqueue_t *pq, unsigned int pri, void *elem);


/*
Returnerer det element som har hjst prioritet. Hvis flere elementer
har samme hjeste prioritet returneres det af dem, som frst blev indsat.

Hvis ken er tom, returneres 'NULL'.
*/
void *pqueue_remove(pqueue_t *pq);


/* opretter en ny k */
pqueue_t *init_queue();


#endif
