#include <stdio.h>

#include <wqueue.h>

wqueue_t wq = WQUEUE_INIT;

char out[100];

void print_res(void *data) {
    printf("%s", (char *)data);
}

void calc(void *data) {
    int *op = data, sum;

    sum = op[0] + op[1];
    sprintf(out, "sum=%d\n", sum);

    wqueue_insert(&wq, 0, print_res, out);
}



int main(int argc, const char* argv[]) {
    int op[] = {15, 7};

    wqueue_insert(&wq, 0, calc, op);

    while (wqueue_run(&wq) == 1);

    return 0;
}
